<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ConfigurePortDialog xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ConfigurePortDialog.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.transformation.ui.dialogs;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Collections;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.UniqueEList;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EClassifier;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EStructuralFeature;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.MessageDialog;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ArrayContentProvider;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelection;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelectionChangedListener;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.SelectionChangedEvent;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.StructuredSelection;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.TableViewer;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.PortKind;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.PortUtils;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.ui.Messages;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.DescriptionUtils;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.editors.TreeSelectorDialog;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.toolbox.utils.DialogUtils;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.providers.ServiceEditFilteredContentProvider;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.providers.UMLLabelProvider;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.SWT;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionEvent;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionListener;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.layout.GridData;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.layout.GridLayout;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Button;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Combo;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Composite;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Control;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Display;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Group;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Label;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Text;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.dialogs.SelectionStatusDialog;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment"> * Select container rules, either from a list of globally defined rules or from</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment"> * local rules which may be created "on the fly" by this dialog.</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment"> * TODO: extend rule application to instances (problematic, since rules</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment"> * transformation is done on type level)</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ConfigurePortDialog.html">ConfigurePortDialog</a> <strong class="jxr_keyword">extends</strong> SelectionStatusDialog {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	<strong class="jxr_keyword">protected</strong> Class m_component;
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<strong class="jxr_keyword">protected</strong> Text fDescription;
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	<strong class="jxr_keyword">protected</strong> TableViewer fPortList;
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/FCM/Port.html">Port</a> m_currentPort;
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  	<strong class="jxr_keyword">protected</strong> Combo fKindCombo;
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  	<strong class="jxr_keyword">protected</strong> EList&lt;PortKind&gt; portKindList;
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  	<strong class="jxr_keyword">protected</strong> Label fType;
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  	<strong class="jxr_keyword">protected</strong> Button fTypeButton;
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	<strong class="jxr_keyword">protected</strong> Label fProvided;
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  	<strong class="jxr_keyword">protected</strong> Label fRequired;
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  	<strong class="jxr_keyword">protected</strong> Package m_model;
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	<strong class="jxr_keyword">protected</strong> EList&lt;Port&gt; m_ports;
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String COLON = <span class="jxr_string">":"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ConfigurePortDialog.html">ConfigurePortDialog</a>(Shell parent) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<strong class="jxr_keyword">super</strong>(parent);
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 	}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> init(<a href="../../../../../../../../org/eclipse/papyrus/designer/components/FCM/Port.html">Port</a> port) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<em class="jxr_comment">// visitedPackages = new BasicEList&lt;Package&gt; ();</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		m_component = port.getClass_();
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		m_currentPort = port; <em class="jxr_comment">// preselect port (don't call selectPort before initialization of dialog area);</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		m_model = PackageUtil.getRootPackage(m_component);
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		m_ports = PortUtils.getAllPorts(m_component);
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 	}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> init(Class clazz) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		<em class="jxr_comment">// visitedPackages = new BasicEList&lt;Package&gt; ();</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		m_component = clazz;
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		m_model = PackageUtil.getRootPackage(m_component);
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		m_currentPort = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		m_ports = PortUtils.getAllPorts(m_component);
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 	}
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> <em class="jxr_javadoccomment">	 * @see SelectionStatusDialog#computeResult()</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 	@Override
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> computeResult() {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		<em class="jxr_comment">// nothing to do</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 	}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	@Override
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	<strong class="jxr_keyword">public</strong> Control createDialogArea(Composite parent) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		Composite contents = (Composite) <strong class="jxr_keyword">super</strong>.createDialogArea(parent);
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		<em class="jxr_comment">// (parent, "Container rules", "Avail. extensions/interceptors");</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		createPortConfigurationGroup(contents);
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		<strong class="jxr_keyword">if</strong> (m_currentPort != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 			<strong class="jxr_keyword">int</strong> index = m_ports.indexOf(m_currentPort);
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 			<strong class="jxr_keyword">if</strong> (index != -1) {
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 				fPortList.getTable().setSelection(index);
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 				selectPort(m_currentPort);
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 			}
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		}
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		<strong class="jxr_keyword">return</strong> contents;
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 	}
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 	<em class="jxr_comment">// create instance configuration group</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> createPortConfigurationGroup(Composite parent) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		GridData groupGridData = DialogUtils.createFillGridData();
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<em class="jxr_comment">// create grid data</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		GridData gridData = DialogUtils.createFillGridData();
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		GridData gridDataH80Span2 = DialogUtils.createFillGridData();
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		gridDataH80Span2.horizontalSpan = 2;
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		gridDataH80Span2.heightHint = 80;
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		GridData gridDataH25Span2 = DialogUtils.createFillGridData();
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		gridDataH25Span2.horizontalSpan = 2;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		gridDataH25Span2.heightHint = 25;
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		GridData gridDataH60 = DialogUtils.createFillGridData();
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		gridDataH60.heightHint = 60;
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		GridData gridDataSpan2 = DialogUtils.createFillGridData();
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 		gridDataSpan2.horizontalSpan = 2;
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		<em class="jxr_comment">// fRuleName = new Text (ruleInfoGroup, SWT.NONE);</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		Group portSelection = <strong class="jxr_keyword">new</strong> Group(parent, SWT.BORDER);
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 		portSelection.setLayout(<strong class="jxr_keyword">new</strong> GridLayout(1, false));
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		<em class="jxr_comment">// configL.setLayout(new RowLayout());</em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 		portSelection.setText(<span class="jxr_string">" "</span> + Messages.ConfigurePortDialog_AvailPorts + <span class="jxr_string">" "</span>); <em class="jxr_comment">//$NON-NLS-1$ //$NON-NLS-2$</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		portSelection.setLayoutData(gridDataH60);
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		fPortList = <strong class="jxr_keyword">new</strong> TableViewer(portSelection, SWT.BORDER);
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 		fPortList.setLabelProvider(<strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/PortLabelProvider.html">PortLabelProvider</a>());
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		fPortList.setContentProvider(<strong class="jxr_keyword">new</strong> ArrayContentProvider());
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 		fPortList.setInput(m_ports.toArray());
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		fPortList.getTable().setLayoutData(gridDataH60);
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		fPortList.addSelectionChangedListener(<strong class="jxr_keyword">new</strong> ISelectionChangedListener() {
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 			@Override
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> selectionChanged(SelectionChangedEvent event) {
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 				ISelection selection = fPortList.getSelection();
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 				<strong class="jxr_keyword">if</strong> (selection instanceof StructuredSelection) {
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 					Object[] selected = ((StructuredSelection) selection)
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 							.toArray();
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 					<strong class="jxr_keyword">if</strong> ((selected.length == 1)
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 							&amp;&amp; (selected[0] instanceof Port)) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 						selectPort((Port) selected[0]);
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 					}
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 				}
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			}
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		});
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		portSelection.pack();
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		Group instanceConfigurationGroup = <strong class="jxr_keyword">new</strong> Group(parent, SWT.BORDER);
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		instanceConfigurationGroup.setText(<span class="jxr_string">" "</span> + Messages.ConfigurePortDialog_AvailPorts + <span class="jxr_string">" "</span>); <em class="jxr_comment">//$NON-NLS-1$ //$NON-NLS-2$</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 		instanceConfigurationGroup.setLayout(<strong class="jxr_keyword">new</strong> GridLayout(2, false));
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		instanceConfigurationGroup.setLayoutData(groupGridData);
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 		Label kindText = <strong class="jxr_keyword">new</strong> Label(instanceConfigurationGroup, SWT.NONE);
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 		kindText.setText(Messages.ConfigurePortDialog_Kind + COLON);
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 		fKindCombo = <strong class="jxr_keyword">new</strong> Combo(instanceConfigurationGroup, SWT.NONE);
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		portKindList = getAvailableKinds(m_model);
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		<strong class="jxr_keyword">if</strong> (portKindList.size() == 0) {
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 			MessageDialog.openInformation(Display.getDefault().getActiveShell(), <span class="jxr_string">"No port kinds founds"</span>, <span class="jxr_string">"No port kinds are available. Please import a SW Designer model library"</span>);
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		}
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		String[] portKindStrList = <strong class="jxr_keyword">new</strong> String[portKindList.size() + 1];
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 		portKindStrList[0] = Messages.ConfigurePortDialog_None;
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 		<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; portKindList.size(); i++) {
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 			portKindStrList[i + 1] = portKindList.get(i).getBase_Class().getName();
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 		}
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 		fKindCombo.setItems(portKindStrList);
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 		fKindCombo.addSelectionListener(<strong class="jxr_keyword">new</strong> SelectionListener() {
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 			@Override
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 				<em class="jxr_comment">// changePortKind</em>
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 				org.eclipse.papyrus.designer.components.FCM.Port fcmPort = StereotypeUtil.applyApp(m_currentPort, org.eclipse.papyrus.designer.components.FCM.Port.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 				<strong class="jxr_keyword">if</strong> (fcmPort != <strong class="jxr_keyword">null</strong>)
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 				{
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 					<strong class="jxr_keyword">int</strong> index = fKindCombo.getSelectionIndex();
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 					<strong class="jxr_keyword">if</strong> (index &gt; 0) {
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 						PortKind kind = portKindList.get(index - 1);
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 						fcmPort.setKind(kind);
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 						selectPort(m_currentPort);
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 					}
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 					<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 						StereotypeUtil.unapply(m_currentPort, org.eclipse.papyrus.designer.components.FCM.Port.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 						selectPort(m_currentPort);
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 					}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 				}
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			}
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			@Override
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetDefaultSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 			}
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 		});
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		Label fTypeLabel = <strong class="jxr_keyword">new</strong> Label(instanceConfigurationGroup, SWT.NONE);
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 		fTypeLabel.setText(Messages.ConfigurePortDialog_Type + COLON);
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 		fTypeLabel.setLayoutData(gridData);
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		fType = <strong class="jxr_keyword">new</strong> Label(instanceConfigurationGroup, SWT.NONE);
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 		fType.setLayoutData(gridData);
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 		fTypeButton = <strong class="jxr_keyword">new</strong> Button(instanceConfigurationGroup, SWT.NONE);
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 		fTypeButton.setText(Messages.ConfigurePortDialog_ChangeType);
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 		fTypeButton.setLayoutData(gridDataH25Span2);
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 		fTypeButton.addSelectionListener(<strong class="jxr_keyword">new</strong> SelectionListener() {
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 			@Override
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 				<em class="jxr_comment">// use Papyrus type selection dialog ...</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 				TreeSelectorDialog tsd = <strong class="jxr_keyword">new</strong> TreeSelectorDialog(Display.getDefault().getActiveShell());
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 				EStructuralFeature feature = UMLPackage.eINSTANCE.getTypedElement_Type();
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 				ServiceEditFilteredContentProvider contentProvider =
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 						<strong class="jxr_keyword">new</strong> ServiceEditFilteredContentProvider(m_currentPort, feature, <strong class="jxr_keyword">new</strong> EObject[] { m_model });
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 				EList&lt;EClassifier&gt; wantedMetaClasses = <strong class="jxr_keyword">new</strong> BasicEList&lt;EClassifier&gt;();
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 				wantedMetaClasses.add(feature.getEType());
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 				<em class="jxr_comment">// creates (indirect) dependency to org.eclipse.emf.facet.infra.browser.uicore.CustomizableModelContentProvider</em>
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 				contentProvider.setWantedMetaclasses(wantedMetaClasses);
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 				contentProvider.setNotWantedMetaclasses(Collections.EMPTY_LIST);
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 				tsd.setContentProvider(contentProvider);
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 				tsd.setLabelProvider(<strong class="jxr_keyword">new</strong> UMLLabelProvider());
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 				tsd.open();
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 				Object result[] = tsd.getResult();
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 				<strong class="jxr_keyword">if</strong> ((result != <strong class="jxr_keyword">null</strong>) &amp;&amp; (result.length == 1)) {
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 					<em class="jxr_comment">// if(result[0] instanceof IAdaptable) {</em>
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 					<em class="jxr_comment">// Object type = ((IAdaptable)result[0]).getAdapter(EObject.class);</em>
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 					Object type = result[0];
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 					<strong class="jxr_keyword">if</strong> (type instanceof Type) {
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 						m_currentPort.setType((Type) type);
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 						selectPort(m_currentPort);
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 					}
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 				}
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 			}
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 			@Override
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetDefaultSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			}
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 		});
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		<em class="jxr_comment">// Label emptySpace = new Label(instanceConfigurationGroup, SWT.NONE);</em>
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 		<em class="jxr_comment">// emptySpace.setLayoutData(gridDataSpan2);</em>
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 		<em class="jxr_comment">// Composite derivedInterfaces = new Composite(instanceConfigurationGroup, SWT.NONE);</em>
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 		Group derivedInterfaces = <strong class="jxr_keyword">new</strong> Group(instanceConfigurationGroup, SWT.NONE);
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 		derivedInterfaces.setLayout(<strong class="jxr_keyword">new</strong> GridLayout(2, false));
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 		<em class="jxr_comment">// Label dil = new Label(derivedInterfaces, SWT.NONE);</em>
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 		<em class="jxr_comment">// dil.setText("Interfaces derived from port kind");</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 		derivedInterfaces.setText(Messages.ConfigurePortDialog_IntfDerived);
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 		<em class="jxr_comment">// dil.setLayoutData(gridDataSpan2);</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 		derivedInterfaces.setLayoutData(gridDataSpan2);
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 		Label fProvidedLabel = <strong class="jxr_keyword">new</strong> Label(derivedInterfaces, SWT.NONE);
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 		fProvidedLabel.setText(Messages.ConfigurePortDialog_Provided + COLON);
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 		fProvided = <strong class="jxr_keyword">new</strong> Label(derivedInterfaces, SWT.NONE);
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 		fProvided.setLayoutData(gridData);
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 		Label fRequiredLabel = <strong class="jxr_keyword">new</strong> Label(derivedInterfaces, SWT.NONE);
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 		fRequiredLabel.setText(Messages.ConfigurePortDialog_Required + COLON);
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 		fRequired = <strong class="jxr_keyword">new</strong> Label(derivedInterfaces, SWT.NONE);
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 		fRequired.setLayoutData(gridData);
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 		derivedInterfaces.pack();
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 		fDescription = <strong class="jxr_keyword">new</strong> Text(instanceConfigurationGroup, SWT.NONE | SWT.WRAP
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 				| SWT.V_SCROLL | SWT.READ_ONLY);
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 		fDescription.setLayoutData(gridDataH80Span2);
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 		<em class="jxr_comment">// createMessageArea (ruleInfoGroup);</em>
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 		instanceConfigurationGroup.pack();
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 		setEnabled(false);
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 	}
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L321" href="#L321">321</a> <em class="jxr_javadoccomment">	 * Select a rule, i.e. update the visual representation from the rule</em>
<a class="jxr_linenumber" name="L322" href="#L322">322</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L323" href="#L323">323</a> <em class="jxr_javadoccomment">	 * @param rule</em>
<a class="jxr_linenumber" name="L324" href="#L324">324</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> selectPort(<a href="../../../../../../../../org/eclipse/papyrus/designer/components/FCM/Port.html">Port</a> port) {
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 		m_currentPort = port;
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 		<strong class="jxr_keyword">if</strong> (port == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 			setEnabled(false);
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 		}
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 		setEnabled(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 		org.eclipse.papyrus.designer.components.FCM.Port fcmPort = UMLUtil.getStereotypeApplication(port, org.eclipse.papyrus.designer.components.FCM.Port.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 		<strong class="jxr_keyword">if</strong> (port.getType() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 			fType.setText(port.getType().getQualifiedName());
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 		}
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 			fType.setText(Messages.ConfigurePortDialog_Undef);
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 		}
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 		<strong class="jxr_keyword">if</strong> ((fcmPort != <strong class="jxr_keyword">null</strong>) &amp;&amp; (fcmPort.getKind() != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 			PortKind kind = fcmPort.getKind();
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 			<strong class="jxr_keyword">if</strong> (portKindList.contains(kind)) {
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 				<strong class="jxr_keyword">int</strong> index = portKindList.indexOf(kind) + 1;
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 				fKindCombo.select(index);
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 			}
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 			fDescription.setText(DescriptionUtils.getDescription(kind.getBase_Class(), Messages.ConfigurePortDialog_NotAvail));
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 			Interface providedI = PortUtils.getProvided(port);
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 			Interface requiredI = PortUtils.getRequired(port);
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 			fProvided.setText(providedI != <strong class="jxr_keyword">null</strong> ? providedI.getQualifiedName() : Messages.ConfigurePortDialog_None);
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 			fRequired.setText(requiredI != <strong class="jxr_keyword">null</strong> ? requiredI.getQualifiedName() : Messages.ConfigurePortDialog_None);
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 		}
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 			fProvided.setText(port.getProvideds().size() &gt; 0 ? port.getProvideds().get(0).getQualifiedName() : Messages.ConfigurePortDialog_None);
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 			fRequired.setText(port.getRequireds().size() &gt; 0 ? port.getRequireds().get(0).getQualifiedName() : Messages.ConfigurePortDialog_None);
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 			fKindCombo.select(0);
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 			fDescription.setText(<span class="jxr_string">""</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 		}
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 	}
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> setEnabled(<strong class="jxr_keyword">boolean</strong> enabled) {
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 		fDescription.setEnabled(enabled);
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 		<strong class="jxr_keyword">if</strong> (!enabled) {
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 			fDescription.setText(<span class="jxr_string">""</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 		}
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 	}
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 	<strong class="jxr_keyword">protected</strong> EList&lt;PortKind&gt; getAvailableKinds(Package pkg) {
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 		EList&lt;PortKind&gt; portKindList = <strong class="jxr_keyword">new</strong> UniqueEList&lt;PortKind&gt;();
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 		EList&lt;Package&gt; visitedPackages = <strong class="jxr_keyword">new</strong> BasicEList&lt;Package&gt;();
<a class="jxr_linenumber" name="L369" href="#L369">369</a> 		getAvailableKinds(pkg, portKindList, visitedPackages);
<a class="jxr_linenumber" name="L370" href="#L370">370</a> 		<strong class="jxr_keyword">return</strong> portKindList;
<a class="jxr_linenumber" name="L371" href="#L371">371</a> 	}
<a class="jxr_linenumber" name="L372" href="#L372">372</a> 
<a class="jxr_linenumber" name="L373" href="#L373">373</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> getAvailableKinds(Package pkg, EList&lt;PortKind&gt; portKindList, EList&lt;Package&gt; visitedPackages) {
<a class="jxr_linenumber" name="L374" href="#L374">374</a> 		<strong class="jxr_keyword">for</strong> (Element el : pkg.getMembers()) {
<a class="jxr_linenumber" name="L375" href="#L375">375</a> 			<strong class="jxr_keyword">if</strong> (el instanceof Package) {
<a class="jxr_linenumber" name="L376" href="#L376">376</a> 				<strong class="jxr_keyword">if</strong> (!visitedPackages.contains(el)) {
<a class="jxr_linenumber" name="L377" href="#L377">377</a> 					visitedPackages.add((Package) el);
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 					getAvailableKinds((Package) el, portKindList, visitedPackages);
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 				}
<a class="jxr_linenumber" name="L380" href="#L380">380</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (el instanceof Class) {
<a class="jxr_linenumber" name="L381" href="#L381">381</a> 				PortKind portKind = UMLUtil.getStereotypeApplication(el, PortKind.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L382" href="#L382">382</a> 				<strong class="jxr_keyword">if</strong> (portKind != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L383" href="#L383">383</a> 					portKindList.add(portKind);
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 				}
<a class="jxr_linenumber" name="L385" href="#L385">385</a> 			}
<a class="jxr_linenumber" name="L386" href="#L386">386</a> 		}
<a class="jxr_linenumber" name="L387" href="#L387">387</a> 	}
<a class="jxr_linenumber" name="L388" href="#L388">388</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
